#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';
require_once 'functions.inc';
//Options

$shorts = "";
$shorts .= "o:";
$shorts .= "v:";
$shorts .= "s:";
$shorts .= "d:";

$longs = array(
    "org:",
    "vdc:",
    "syslog",
    "debug:",
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
    case "o":
        $opOrg = $opts['o'];
        break;
    case "org":
        $opOrg = $opts["org"];
        break;

    case "v":
        $vdcName = $opts["v"];
        break;
    case "vdc":
        $vcdName = $opts["vdc"];
        break;

    case "s":
        $sysLogIp = $opts["s"];
        break;
    case "syslog":
        $sysLogIp = $opts["syslog"];
        break;

    case "d":
        $debug = true;
        break;
    case "debug":
        $debug = true;
        break;
}

if(!isset($opOrg) || !isset($vdcName) || !isset($sysLogIp)) {
    echo "Error: Missing parameter lsorgnet -o <organization> -v <vdc> -s <syslogserver>\n";
    exit(1);
}

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$adminSdk = $service->createSDKAdminObj();

$edgeGatewayRef = getOrgEdgeGW($service,$opOrg,$vdcName);
$SDKedgeGateway = $service->createSDKObj($edgeGatewayRef->get_href());
$edgeGateway    = $SDKedgeGateway->getEdgeGateway();
$gatewayConfiguration = $edgeGateway->getConfiguration();
$gatewayInterfaces = $gatewayConfiguration->getGatewayInterfaces();
$gatewayInterfaces = $gatewayInterfaces->getGatewayInterface();
foreach($gatewayInterfaces as $gatewayInterface) {
    if($gatewayInterface->getInterfaceType() == "internal" ) {
        $networkRef = $gatewayInterface->getNetwork();
        echo var_dump($networkRef);
        $SDKnetwork = $service->createSDKObj($networkRef->get_href());
        echo var_dump($SDKnetwork);
        $network    = $SDKnetwork->getNetwork();
        echo var_dump($network);
        echo $network->export();
    }
}
//echo $gatewayInterfaces->export();


/*
$orgRefs = $adminSdk->getAdminOrgRefs($opOrg);
if (!empty($orgRefs))
{
    echo "-=ORG " . $orgRefs[0]->get_name() . " =-\n";
    $sdkOrg  = $service->createSDKObj($orgRefs[0]);
    $vdcRefs = $sdkOrg->getAdminVdcRefs();
    if(!empty($vdcRefs))
    {
        foreach($vdcRefs as $vdcRef) {
            if ($vdcName == $vdcRef->get_name()) {
                echo "=vDC " . $vdcRef->get_name() . " =\n";
                $sdkVdc = $service->createSDKObj($vdcRef);
                $netRefs = $sdkVdc->getOrgVdcNetworks();
                if (!empty($netRefs)) {
                    foreach ($netRefs as $netRef) {
                        echo $netRef->get_name() . "\n";
                        if (isset($debug)) {
                            echo $netRef->export() . "\n";
                        }
                        $orgNetwork = addSyslogService($service, $netRef, $sysLogIp);
                        $sdkOrgNetwork = $service->createSDKObj($orgNetwork->get_href());
                        if (isset($debug)) {
                            echo $orgNetwork->export() . "\n";

                        }
                        exit();
                        $task = $sdkOrgNetwork->modify($orgNetwork);

                        $task = $service->waitForTask($task);
                        if ($task->get_status() != 'success'){
                            exit('Failed to update syslog server for network.');
                        } else {
                            echo "Syslog added successfully\n";
                        }

                    }
                }
            }
        }
    }
}
*/
// log out
$service->logout();

function addSyslogService($service,$netRef,$syslogIp)
{
    //add Syslog service to Org Network object
    $sdkNetwork = $service->createSDKObj($netRef);
    $orgNetwork = $sdkNetwork->getNetwork();
    echo var_dump($orgNetwork);
    $networkConfiguration = $orgNetwork->getConfiguration();

    $syslog = new VMware_VCloud_API_SyslogServerSettingsType();
    $syslog->setSyslogServerIp1($syslogIp);

    $networkConfiguration->setSyslogServerSettings($syslog);

    $orgNetwork->setConfiguration($networkConfiguration);

    return $orgNetwork;
}

?>