<?php
/**
 * Created by PhpStorm.
 * User: Phil.Spencer
 * Date: 8/15/2018
 * Time: 10:20 AM
 */

require_once dirname(__FILE__) . '/config.php';
require_once 'functions.inc';

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$orgRefs = $service->getOrgRefs();
if (!empty($orgRefs)) {
    foreach ($orgRefs as $ref) {
        echo $ref->get_name() . "\n";
        $sdkOrg = $service->createSDKObj($ref);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                //$edgeGateway = getOrgEdgeGW($service,$ref->get_name(),$vdcRef->get_name());
                $sdkVdc = $service->createSDKObj($vdcRef);
                $edgeRefs = $sdkVdc->getEdgeGatewayRefs();
                if(!empty($edgeRefs)) {
                    foreach($edgeRefs as $edgeRef) {
                        $extIPs = getEdgeAllExtIp($service, $edgeRef);
                        //echo var_dump($extIPs);
                        echo "Primary IP: " . $extIPs[0]->getIpAddress() . "\n";
                        try {
                            $extIpRanges = $extIPs[0]->getIpRanges();
                            if(!empty($extIpRanges)) {
                                $extIpRange = $extIpRanges->getIpRange();

                                foreach ($extIpRange as $IpRange) {
                                    echo $IpRange->getStartAddress() . "-" . $IpRange->getEndAddress() . "\n";
                                }
                            }
                        } catch(Exception $e) {
                            echo "Error getting IP ranges: " . $e . "\n";
                        }
                    }
                }
            }
        }
        echo "\n";
    }
}


?>