#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';
$hr = "<rasd:HostResource xmlns=\"http://schemas.dmtf.org/wbem/wscim/1/common\" xmlns:vcloud=\"http://www.vmware.com/vcloud/v1.5\" xmlns:ns12=\"http://www.vmware.com/vcloud/v1.5\" xmlns:ovf=\"http://schemas.dmtf.org/ovf/envelope/1\" xmlns:ovfenv=\"http://schemas.dmtf.org/ovf/environment/1\" xmlns:cim=\"http://schemas.dmtf.org/wbem/wscim/1/common\" xmlns:rasd=\"http://schemas.dmtf.org/wbem/wscim/1/cim-schema/2/CIM_ResourceAllocationSettingData\" xmlns:vssd=\"http://schemas.dmtf.org/wbem/wscim/1/cim-schema/2/CIM_VirtualSystemSettingData\" xmlns:vmw=\"http://www.vmware.com/schema/ovf\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" vcloud:capacity=\"10240\" vcloud:busSubType=\"VirtualSCSI\" vcloud:busType=\"6\" vcloud:storageProfileOverrideVmDefault=\"true\"></rasd:HostResource>";
//Options

$shorts = "";
$shorts .= "o:";
$shorts .="v:";

$longs = array(
    "org:",
    "vm:",
    "change:",
    "bus:",
    "id:",
    "tier:"
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
    case "o":
        $opOrg = $opts['o'];
        break;
    case "org":
        $opOrg = $opts["org"];
        break;

    case "v":
        $findVm = $opts['v'];
        break;
    case "vm":
        $findVm = $opts['vm'];
        break;
    case "change":
        $change = 1;
        break;
    case "bus":
        $bus = $opts['bus'];
        break;
    case "id":
        $id = $opts['id'];
        break;
    case "tier":
        $tier = $opts['tier'];
        break;
}

if(!isset($opOrg) || !isset($findVm)) {
    echo "Error: Missing parameter findvm -o <organization> -v <vm>\n";
    exit(1);
}
if(isset($change)) {
    if(!isset($bus) || !isset($id) || !isset($tier)) {
        echo "Error you cannot apply a tier change without the --bus --id and --tier settings\n";
        exit(1);
    }
}
// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$orgRefs = $service->getOrgRefs($opOrg);
if (!empty($orgRefs))
{
    echo "-=ORG " . $orgRefs[0]->get_name() . " =-\n";
    $sdkOrg  = $service->createSDKObj($orgRefs[0]);
    $vdcRefs = $sdkOrg->getVdcRefs();
    if(!empty($vdcRefs))
    {
        foreach($vdcRefs as $vdcRef) {
            echo "=vDC " . $vdcRef->get_name() . " =\n";
            $sdkVdc = $service->createSDKObj($vdcRef);
            $vappRefs = $sdkVdc->getVAppRefs();
            if(!empty($vappRefs)) {
                foreach($vappRefs as $vappRef) {
                    $sdkvApp = $service->createSDKObj($vappRef);
                    $vmRefs = $sdkvApp->getContainedVmRefs();
                    foreach($vmRefs as $vmRef) {
                        if ($vmRef->get_name() == $findVm) {
                            echo $vappRef->get_name() . "\n";
                            echo "* " . $vmRef->get_name() . "\n";


                        }
                    }
                }
            }
        }
    }
}

// log out
$service->logout();

?>
