#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';

//Options

$shorts = "";
$shorts .= "o:";
$shorts .= "v:";
$shorts .= "i:";

$longs = array(
  "org:",
  "verbose:",
  "ipsec:",
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
  case "o":
    $opOrg = $opts['o'];
    system("export VCDORG=". $opOrg);
    break;
  case "org":
    $opOrg = $opts["org"];
    system("export VCDORG=". $opOrg);
    break;
    
  case "v":
    $debug = 1;
    break;
  case "verbose":
    $debug = 1;
    break;

  case "i":
      $ipsec = 1;
      break;
  case "ipsec":
      $ipsec = 1;
      break;
}

if(!isset($opOrg)) {
  echo "Warning: Missing parameter lsedgegw -o <organization> \n";
}

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$orgRefs = $service->getOrgRefs($opOrg);
if (!empty($orgRefs))
{
    foreach($orgRefs as $orgRef) {
        echo "-=ORG " . $orgRef->get_name() . " =-\n";
        $sdkOrg = $service->createSDKObj($orgRef);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                echo "=vDC " . $vdcRef->get_name() . " =\n";
                $sdkVdc = $service->createSDKObj($vdcRef);
                $edgeRefs = $sdkVdc->getEdgeGatewayRefs();
                if (!empty($edgeRefs)) {
                    foreach ($edgeRefs as $edgeRef) {
                        echo $edgeRef->get_name() . "\n";
                        if (isset($debug)) {
                            $sdkEdgeGW = $service->createSDKObj($edgeRef);
                            $edgeGW = $sdkEdgeGW->getEdgeGateway();
                            echo $edgeGW->export() . "\n";
                        }
                        if (isset($ipsec)) {
                            $sdkEdgeGW = $service->createSDKObj($edgeRef);
                            $edgeGW = $sdkEdgeGW->getEdgeGateway();
                            $gatewayConfiguration = $edgeGW->getConfiguration();
                            $gatewayServiceConfig = $gatewayConfiguration->getEdgeGatewayServiceConfiguration();
                            $networkServices = $gatewayServiceConfig->getNetworkService();
                            foreach ($networkServices as $networkService) {
                                if ($networkService->get_tagName() == "GatewayIpsecVpnService") {
                                    if ($networkService->getIsEnabled()) echo "Active VPN tunnel on gateway\n";
                                }
                            }

                        }
                    }
                }
            }
        }
    }
}

// log out
$service->logout();
?>
