#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';

//Options

$shorts = "";
$shorts .= "o:"; //Org
$shorts .= "a:"; //Allocated IP's
$shorts .= "u:"; //Unallocated IP's
$longs = array(
  "org:",
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
  	case "o":
    	$orgName = $opts['o'];
    	break;
  	case "org":
    	$orgName = $opts["org"];
    	break;
	case "a":
		$showAllocated = 1;
		break;
	case "allocated":
		$showAllocated = 1;
		break;
	case "u":
		$showUnallocated = 1;
		break;
	case "unallocated":
		$showUnallocated = 1;
		break;
}

if(!isset($orgName)) {
  echo "Error: Missing parameter lsextnet -o <organization> \n";
  exit(1);
}

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

showExternalNetworks($service,$orgName);

// log out
$service->logout();

function showExternalNetworks($service,$orgName) {
	global $showAllocated;
	global $showUnallocated;

    // create sdk admin object
    $sdkAdminObj = $service->createSDKAdminObj();

    // create admin org object
    $adminOrgRefs = $sdkAdminObj->getAdminOrgRefs($orgName);
    if(empty($adminOrgRefs))
    {
        exit("No admin org with name $orgName is found.");
    } 
  
    $adminOrgRef = $adminOrgRefs[0];
    echo "-=" . $adminOrgRef->get_name() . "=-\n";
    $adminOrgObj = $service->createSDKObj($adminOrgRef->get_href());

    // create admin vdc object
    $adminVdcRefs = $adminOrgObj->getAdminVdcRefs();
    if(empty($adminVdcRefs))
    {
        exit("No admin vdc with name $vdcName is found.");
    }
     
    foreach($adminVdcRefs as $adminVdcRef) {
    	echo "-" . $adminVdcRef->get_name() . "-\n";
    	$adminVdcObj    = $service->createSDKObj($adminVdcRef->get_href());
    	$adminVdcType   = $adminVdcObj->getAdminVdc();
    	$providerVdcRef = $adminVdcType->getProviderVdcReference();
    	$sdkProviderVdc = $service->createSDKObj($providerVdcRef);
    	$extNetRefs     = $sdkProviderVdc->getExternalNetworkRefs(); 
    
    	if (0 == count($extNetRefs))
    	{
        	echo "No external network found!\n";
    	} else {
    
    		foreach($extNetRefs as $extNetRef) {
      			echo $extNetRef->get_name() . "\n";
        		$adminNetwork  = $service->createSDKObj($extNetRef);
              	$extnetObj     = $adminNetwork->getAdminNetwork(); //slow call on kingston vcloud-192
        		$configuration = $extnetObj->getConfiguration();
                
              	if(empty($configuration))
    			{
        			exit("$extNetRef->get_name() doesn't have any configuration.");
    			}
    			$ipScopes = $configuration->getIpScopes();
    			if(empty($ipScopes))
    			{
        			exit("$extNetRef->get_name() doesn't have any IP Scopes.");
    			}
        		foreach($ipScopes->getIpScope() as $ipScope) {
    				$gateway      = $ipScope->getGateway();
    				$netmask      = $ipScope->getNetmask();
    				$ipRanges     = $ipScope->getIpRanges();
					$allocatedIps  = populateIps($ipScope->getAllocatedIpAddresses());

    				if(empty($ipRanges))
    				{
        				exit("$extNetRef->get_name() doesn't have any IP Ranges.");
    				}
    				echo "Gateway      : " . $gateway . "\n";
        			foreach($ipRanges->getIpRange() as $ipRange) {
    					$startAddress = $ipRange->getStartAddress();
    					$endAddress = $ipRange->getEndAddress();
        				echo "Address range: " . $startAddress . " " . $endAddress . "\n";
        				echo "Netmask      : " . $netmask . "\n\n";
      					//$extNetRef = VMware_VCloud_SDK_Helper::createReferenceTypeObj($extNetRef->get_href());
						if(isset($showAllocated) || isset($showUnallocated))
						{
							$startLong = ip2long($startAddress);
							$endLong   = ip2long($endAddress);
							do {
								$currentIp  = long2ip($startLong);
								if(isset($allocatedIps[$currentIp])) {
									if(isset($showAllocated))
										echo "A: " . $currentIp . "\n";
								} else {
									if(isset($showUnallocated))
										echo $currentIp . "\n";
								}
								$startLong++; //maybe this will work
							} while ($startLong <= $endLong);
						}
    				}
    			}
    		}
    	}
    }
    return;
}

function populateIps($ipAddresses) {
	//Turn numerical indexed array into keybased to make finding what we want easier later
	$ipReturn = array();
	$ipArray = $ipAddresses->getIpAddress();
	foreach($ipArray as $ip)
	{
		$ipReturn[$ip] = 1; //populate key based array
	}
	return $ipReturn;
}
?>
