#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';

//Options

$shorts = "";
$shorts .= "o:";
$shorts .= "v:";

$longs = array(
  "org:",
  "verbose:",
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
  	case "o":
		$opOrg = $opts['o'];
    	break;
  	case "org":
    	$opOrg = $opts["org"];
    	break;
    
  	case "v":
    	$debug = true;
    	break;
  	case "verbose":
    	$debug = true;
    	break;
}

if(!isset($opOrg)) {
  echo "Error: Missing parameter lsorgnet -o <organization> \n";
  exit(1);
}

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$orgRefs = $service->getOrgRefs($opOrg);
if (!empty($orgRefs))
{
  	echo "-=ORG " . $orgRefs[0]->get_name() . " =-\n";
	$sdkOrg  = $service->createSDKObj($orgRefs[0]);
    $vdcRefs = $sdkOrg->getVdcRefs();
    if(!empty($vdcRefs))
    {
        foreach($vdcRefs as $vdcRef) {
    		echo "=vDC " . $vdcRef->get_name() . " =\n";
            $sdkVdc = $service->createSDKObj($vdcRef);
        	$netRefs = $sdkVdc->getAvailableNetworks();
            if(!empty($netRefs)) {
              	foreach($netRefs as $netRef) {
                	echo $netRef->get_name() . "\n";	
				 	if(isset($debug)) {
                      	echo $netRef->export() . "\n";
                 	}
              	}
            }
        }
    }
}

// log out
$service->logout();
?>
