#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';

//Options

$shorts = "";
$shorts .= "o:";

$longs = array(
  "org:",
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
  case "o":
    $opOrg = $opts['o'];
    system("export VCDORG=". $opOrg);
    break;
  case "org":
    $opOrg = $opts["org"];
    system("export VCDORG=". $opOrg);
    break;
}

if(!isset($opOrg)) {
  echo "Error: Missing parameter lsvapps -o <organization> \n";
  exit(1);
}

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$orgRefs = $service->getOrgRefs($opOrg);
if (!empty($orgRefs))
{
  	echo "-=ORG " . $orgRefs[0]->get_name() . " =-\n";
	$sdkOrg  = $service->createSDKObj($orgRefs[0]);
    $vdcRefs = $sdkOrg->getVdcRefs();
    if(!empty($vdcRefs))
    {
        foreach($vdcRefs as $vdcRef) {
    		echo "=vDC " . $vdcRef->get_name() . " =\n";
            $sdkVdc = $service->createSDKObj($vdcRef);
        	$vappRefs = $sdkVdc->getVAppRefs();
            if(!empty($vappRefs)) {
              foreach($vappRefs as $vappRef) {
                 echo $vappRef->get_name() . "\n";	
              }
            }
        }
    }
}

// log out
$service->logout();
?>
