#!/usr/bin/php
<?php
require_once dirname(__FILE__) . '/config.php';
require_once 'functions.inc';

//Options

$shorts = "";
$shorts .= "o:";
$shorts .= "e:";
$shorts .= "v:";

$longs = array(
  "org:",
  "extnet:",
  "vdc:",
);

$opts = getopt($shorts,$longs);

foreach (array_keys($opts) as $opt) switch ($opt)
{
  	case "o":
    	$orgName = $opts['o'];
    	break;
  	case "org":
    	$orgName = $opts["org"];
    	break;
    
  	case "v":
    	$vdcName = $opts["v"];
    	break;
    case "vdc":
    	$vcdName = $opts["vdc"];
    	break;
    
  	case "e":
    	$extNetName = $opts['e'];
    	break;
  	case "extnet":
    	$extNetName = $opts['extnet'];
    	break;
    
}

if(!isset($orgName) || !isset($vdcName)) {
  echo "Error: Missing parameter provisionVdcNetwork -o <organization> -v <vdc name> -e <extnet>\n";
  exit(1);
}

// Initialize parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig, $sdkVersion);

$edgeGateway = getOrgEdgeGW($service,$orgName,$vdcName);
createOrgNetwork($service,$orgName,$vdcName,$edgeGateway);

  // log out
$service->logout();

?>
