<?php
/**
 * Created by PhpStorm.
 * User: Phil.Spencer
 * Date: 3/21/2019
 * Time: 10:48 AM
 */

$start = time();
require_once'Console/Table.php';
require_once 'config.php';

// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig,$sdkVersion);

// create an SDK Query object
$sdkQuery = VMware_VCloud_SDK_Query::getInstance($service);

//vDC data
$page = 1;
$params = new VMware_VCloud_SDK_Query_Params();
$params->setPageSize(128);
$params->setPage($page);
while(1) {
    try {
        $recsObj = $sdkQuery->queryRecords("adminOrgVdc", $params);
    } catch (Exception $e) {
        break;
    }
    foreach ($recsObj->getRecord() as $record) {
        try {
            $orgName = $record->get_orgName();
            $orgRefs = $service->getOrgRefs($orgName);
            $ref = $orgRefs[0];
            if($record->get_isEnabled()) //only show active vdc
                $vDCArray[$record->get_name()] = array(round($record->get_storageUsedMB() / getAccurateStorageLimit($service, $ref) * 100), round($record->get_storageUsedMB() / 1000), round(getAccurateStorageLimit($service, $ref) / 1000), round($record->get_cpuUsedMhz() / 1000), round($record->get_cpuLimitMhz() / 1000), round($record->get_cpuUsedMhz() / $record->get_cpuLimitMhz() * 100), round($record->get_memoryUsedMB() / 1000), round($record->get_memoryLimitMB() / 1000), round($record->get_memoryUsedMB() / $record->get_memoryLimitMB() * 100));
        } catch (Exception $e) { }
    }
    $page++;
    $params->setPage($page);
}

//Datastore & vDC report
$vDCDatastoreReport = new Console_Table();
$vDCDatastoreReport->setHeaders(array("vDC", "Allocated (GB)", "Total (GB)", "%"));
$vDCReport = new Console_Table();
$vDCReport->setHeaders(array("vDC", "CPU usage/total","%", "RAM usage/total","%","Storage usage/total","%"));

arsort($vDCArray);
foreach ($vDCArray as $vDCKey => $value) {
  //  $vDCDatastoreReport->addRow(array($vDCKey, $value[1], $value[2], $value[0]));
    $vDCReport->addRow(array($vDCKey, $value[3] . "GHZ/" . $value[4] ."GHZ", $value[5], $value[6] . "GB/" . $value[7] . "GB", $value[8],$value[1] . "GB/" . $value[2] . "GB",$value[0]));
}

//Main Report
$report = new Console_Table();
$report->setHeaders(array("SCC vCloud Report 0.1"));
$report->setAlign(0,CONSOLE_TABLE_ALIGN_CENTER);
$report->addRow(array("vDC Report"));
$report->addRow(array($vDCReport->getTable()));
//$report->addRow(array("vDC Storage allocation"));
//$report->addRow(array($vDCDatastoreReport->getTable()));

$end = time();
$report->addRow(array("Report generated in: " . round((($end - $start) / 60),2) . " minutes"));
echo $report->getTable();
echo "\n";
$service->logout();

function getAccurateStorageLimit($service, $orgref)
{
    /* Work around for vCD 5.1 bug
     * this will check for enabled Storage profiles and only count thier limits
     */
    $accurateStorageLimit = 0;
    $sdkOrg = $service->createSDKObj($orgref);
    $vdcRefs = $sdkOrg->getVdcRefs();
    foreach ($vdcRefs as $vdcRef) {
        $sdkVdc = $service->createSDKObj($vdcRef);
        $vdcStorageProfiles = $sdkVdc->getVdcStorageProfiles();
        foreach ($vdcStorageProfiles as $vdcStorageProfile) {
            if ($vdcStorageProfile->getEnabled() == TRUE) {
                $accurateStorageLimit = $accurateStorageLimit + $vdcStorageProfile->getLimit();
            }
        }
    }
    return $accurateStorageLimit;

}
?>