#!/usr/bin/php
<?php

//findVcenterVM("vse-Lab-Mississauga-GW","System vDC");
//return;
createSSLVPNPlus("edge-62","199.48.102.55","4443","192.168.0.0/24","192.168.0.1","8.8.8.8","","clevrDev",'c13vr%D3vz');

function findVcenterVM($vmName,$orgName) {
    require_once "/home/phil/vCenter/config.php";

    $search   = $vmName;
    $searchRP = $orgName;

    $virtualMachines = $vHost->findAllManagedObjects('VirtualMachine',array('runtime','summary'));
    //echo array_dump($virtualMachines);

    foreach ($virtualMachines as $virtualMachine) {
        if(strstr($virtualMachine->name,$search)) {
           try {
               $vmSummary = $virtualMachine->summary;
               $vmRuntime = $virtualMachine->runtime;
               $resourcePool = $virtualMachine->resourcePool;
               $host = $vmRuntime->host;
        } catch (Exception $e) {
        }
            if (strstr($resourcePool->name, $searchRP)) {

                if ($vmRuntime->powerState == "poweredOn") { //Only output running VMs
                    $vmFolder = $virtualMachine->parent;
                    echo $virtualMachine->name . "\n";
                    echo "Host: " . $host->name . "\n";
                    echo "Resource Pool: " . $resourcePool->name . "\n";

                    $vmQuickStats = $vmSummary->quickStats;
                    $vmStorage = $vmSummary->storage;
                    echo "Active memory: " . $vmQuickStats->guestMemoryUsage . "MB\n";
                    echo "Active CPU: " . $vmQuickStats->overallCpuUsage . "MHZ\n";
                    echo "Used Storage: " . round(($vmStorage->committed / 1024 / 1024 / 1024), 2) . "GB\n\n";
                }
            }
        }
    }
}

function createSSLVPNPlus($edgeId,$externalIp,$externalPort,$internalNetwork,$dns1,$dns2,$dnsSuffix,$username,$password)
{
/*    $edgeId = "edge-114";
    $externalIp = "199.48.102.94";
    $externalPort = "443";
    $internalNetwork = "192.168.1.0/24";
    $dns1 = "192.168.2.1";
    $dns2 = "8.8.8.8";
    $dnsSuffix = "lab.local";
    $username = "vpnuser";
    $password = 'Bcs$zc0!';
*/
    $sslvpnconfig = <<<EOT
<sslvpnConfig><enabled>true</enabled><logging><enable>false</enable><logLevel>info</logLevel></logging><serverSettings>
<ip>$externalIp</ip><port>$externalPort</port><cipherList><cipher>AES128-SHA</cipher></cipherList><sslVersionList/></serverSettings>
<advancedConfig><enableCompression>false</enableCompression><forceVirtualKeyboard>false</forceVirtualKeyboard>
<randomizeVirtualkeys>false</randomizeVirtualkeys><preventMultipleLogon>false</preventMultipleLogon><clientNotification>
</clientNotification><enablePublicUrlAccess>false</enablePublicUrlAccess><timeout><forcedTimeout>0</forcedTimeout>
<sessionIdleTimeout>10</sessionIdleTimeout></timeout></advancedConfig><clientConfiguration><autoReconnect>true</autoReconnect>
<upgradeNotification>false</upgradeNotification></clientConfiguration><layoutConfiguration><portalTitle>VMware</portalTitle>
<companyName>VMware</companyName><logoExtention>jpg</logoExtention>
<logoUri>/3.0/edges/edge-1/sslvpn/config/layout/images/portallogo</logoUri><logoBackgroundColor>FFFFFF</logoBackgroundColor>
<titleColor>996600</titleColor><topFrameColor>000000</topFrameColor><menuBarColor>999999</menuBarColor>
<rowAlternativeColor>FFFFFF</rowAlternativeColor><bodyColor>FFFFFF</bodyColor><rowColor>F5F5F5</rowColor></layoutConfiguration>
<ipAddressPools><ipAddressPool><ipRange>192.168.10.100-192.168.10.150</ipRange><netmask>255.255.255.0</netmask>
<gateway>192.168.10.1</gateway><primaryDns>$dns1</primaryDns><secondaryDns>$dns2</secondaryDns>
<dnsSuffix>$dnsSuffix</dnsSuffix><winsServer></winsServer><description>VPN Pool</description><enabled>true</enabled>
</ipAddressPool></ipAddressPools><privateNetworks><privateNetwork><network>$internalNetwork</network><sendOverTunnel>
<optimize>true</optimize></sendOverTunnel><description>Internal network</description><enabled>true</enabled></privateNetwork>
</privateNetworks><users><user><userId>$username</userId><password>$password</password><firstName></firstName>
<lastName></lastName><description></description><disableUserAccount>false</disableUserAccount>
<passwordNeverExpires>false</passwordNeverExpires></user></users><clientInstallPackages><clientInstallPackage>
<profileName>install-package</profileName><gatewayList><gateway><hostName>$externalIp</hostName><port>$externalPort</port></gateway>
</gatewayList><createLinuxClient>true</createLinuxClient><createMacClient>true</createMacClient>
<startClientOnLogon>false</startClientOnLogon><hideSystrayIcon>false</hideSystrayIcon><rememberPassword>false</rememberPassword>
<silentModeOperation>false</silentModeOperation><silentModeInstallation>false</silentModeInstallation>
<hideNetworkAdaptor>false</hideNetworkAdaptor><createDesktopIcon>true</createDesktopIcon>
<enforceServerSecurityCertValidation>false</enforceServerSecurityCertValidation><description></description><enabled>true</enabled>
</clientInstallPackage></clientInstallPackages><authenticationConfiguration><passwordAuthentication>
<authenticationTimeout>1</authenticationTimeout><primaryAuthServers><localAuthServer><authServerType>local</authServerType>
<order>1</order><isSecondaryAuthServer>false</isSecondaryAuthServer><terminateSessionOnAuthFails>false</terminateSessionOnAuthFails>
<enabled>true</enabled><passwordPolicy><minLength>1</minLength><maxLength>63</maxLength><minAlphabets>0</minAlphabets>
<minDigits>0</minDigits><minSpecialChar>0</minSpecialChar><allowUserIdWithinPassword>true</allowUserIdWithinPassword>
<passwordLifeTime>365</passwordLifeTime><expiryNotification>25</expiryNotification></passwordPolicy></localAuthServer>
</primaryAuthServers><secondaryAuthServer/></passwordAuthentication></authenticationConfiguration></sslvpnConfig>
EOT;
    $url = "https://172.16.255.93/api/3.0/edges/$edgeId/sslvpn/config/";
    $testcommand = "/api/3.0/edges/edge-114/sslvpn/config/";
    $creds = "admin:5831bcs#";

    $headers = array(
        "Content-Type: application/xml",
        "Authorization: Basic " . base64_encode($creds)
    );

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
    curl_setopt($ch, CURLOPT_POSTFIELDS, $sslvpnconfig);

    $data = curl_exec($ch);

    if (curl_errno($ch)) {
        curl_close($ch);
        return -1;
    } else {
        curl_close($ch);
        return 1;
    }
}
?>