<?php
require_once '/home/phil/vcloudPHP-5.5.0/scratch/config.php';
$siteIp = "172.16.1.129/~phil/";
$auth = 0;
if(isset($_POST["cloudLogin"]) && isset($_POST["cloudUser"]) && isset($_POST["cloudPassword"])) {
    $token = cloudLogin($_POST["cloudUser"],$_POST["cloudPassword"]);
    if($token) {
        setcookie("sccloudauth", $token, time() + 3600);
    }
}

if(isset($_COOKIE["sccloudauth"])) { //token contained in Cookie
    $ctoken = $_COOKIE["sccloudauth"];
    try {
        $service = VMware_VCloud_SDK_Service::getService();
        $service->setVcloudToken($server, $ctoken, $httpConfig, $sdkVersion);
        $service->getSession();
        $auth = 1;
    } catch (Exception $e) {
        //No good token
    }
}
if(isset($token)) { //Just logged in, but still check token
    $ctoken = $token;
    try {
        $service = VMware_VCloud_SDK_Service::getService();
        $service->setVcloudToken($server, $ctoken, $httpConfig, $sdkVersion);
        $service->getSession();
        $auth = 1;
    } catch (Exception $e) {
        //No good token
    }
}
?>
<!DOCTYPE html>
    <html>
    <head>
    <meta charset="ISO-8859-1">
    <link href="wmks/css/wmks-all.css" rel="stylesheet" type="text/css" />
    <link rel="stylesheet" type="text/css" href="semantic/dist/semantic.min.css">
    <script src="support/javascript/jquery/jquery-1.7.2.min.js"></script>
    <script src="support/javascript/jquery/jquery-ui.1.8.16.min.js"></script>
    <script src="semantic/dist/semantic.min.js"></script>
    <script type="text/javascript" src="wmks/wmks.min.js" type="text/javascript"></script>

    <style>
        body {
            background-color: #004C8A;
            }
    </style>
        <?php
if($auth == 1) {
    if (isset($_GET["consoleVM"]) && isset($_GET["consolevApp"]) && isset($_GET["consoleOrg"])) {
        //Build  Web MKS console variables from URI
        $vmName = htmlspecialchars_decode($_GET["consoleVM"]); //fixme
        $vmx = "";
        $ticket = "";
        $hostname = "";
        $port = "";
        $vApp = htmlspecialchars_decode($_GET["consolevApp"]);
        $orgName = htmlspecialchars_decode($_GET["consoleOrg"]);
        if ($_GET["newticket"]) {
            try {
                $ticketObj = getMKS($service,$orgName, $vApp, $vmName);
                echo $ticketObj->getTicket();
            } catch (Exception $e) {

            }
            return;
        }
        if ($_GET["startvm"]) {
            startVM($service,$orgName, $vApp, $vmName);
            return;
        }
        if ($_GET["stopvm"]) {
            stopVM($service,$orgName, $vApp, $vmName);
            return;
        }
        if ($_GET["suspendvm"]) {
            suspendVM($service,$orgName, $vApp, $vmName);
            return;
        }
        if ($_GET["resetvm"]) {
            resetVM($service,$orgName, $vApp, $vmName);
            return;
        }
        $ticketObj = getMKS($service,$orgName, $vApp, $vmName);
        if ($ticketObj != NULL) {
            $ticket = $ticketObj->getTicket();
            $vmx = $ticketObj->getVmx();
            $hostname = $ticketObj->getHost();
            $port = $ticketObj->getPort();
        } else {
            echo "No ticket generated";
            exit(1);
        }
    } else {
        //Draw VM list
        drawVms($service);
        exit(1); //End execution here
    }
} else {
    draw_eCloud_login(); //No Cookie or correct login, draw login
    exit(1); //End Execution here
}
//Execute Web MKS console below
?>
    <script>
        $(document).ready(function() {
            var wmks = WMKS.createWMKS("wmksContainer", {
                enableUint8Utf8: true,
                VCDProxyHandshakeVmxPath: "<?php echo $vmx; ?>",})
                .register(WMKS.CONST.Events.CONNECTION_STATE_CHANGE,
                    function (event, data) {
                        if (data.state == WMKS.CONST.ConnectionState.CONNECTED) {
                            console.log("connection state change : connected");
                        }
                        if (data.state == WMKS.CONST.ConnectionState.CONNECTING) {
                            console.log("connection state change : connecting...");
                        }
                        if (data.state == WMKS.CONST.ConnectionState.DISCONNECTED) {
                            console.log("connection state change : disconnected");
                            console.log("Attempting to get new ticket...");
                            var xmlhttp;

                            if(window.XMLHttpRequest) {
                                xmlticket=new XMLHttpRequest();
                            } else {
                                xmlticket=new ActiveXObject("Microsoft.XMLHTTP");
                            }
                            xmlticket.onreadystatechange=function() {
                                if(xmlticket.readyState==4) {
                                    if (xmlticket.status == 200) {
                                        newticket = xmlticket.responseText;
                                        wmks.connect("wss://<?php echo $hostname; ?>/<?php echo $port; ?>;" + newticket);
                                    } else {

                                    }
                                }
                            }
                            xmlticket.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?newticket=1&vmName=" + "<?php echo htmlspecialchars($vmName);?>" + "&org=" + "<?php echo htmlspecialchars($orgName); ?>" + "&vApp=" + "<?php echo htmlspecialchars($vApp);?>");
                            xmlticket.send();
                        }
                });

            wmks.connect("wss://<?php echo $hostname; ?>/<?php echo $port; ?>;<?php echo $ticket; ?>");
            console.log("Connecting to wss://<?php echo $hostname; ?>/<?php echo $port; ?>;<?php echo $ticket; ?>");
            wmks.register(WMKS.CONST.Events.FULL_SCREEN_CHANGE,function(event,data) {
                //Adjust VM to fullscreen
                console.log("Attempting to adjust VM console to new display mode...");
                wmks.updateScreen();
            });
            $("#fullscreen").click(function(){
                console.log("Trying fullscreen...");
                wmks.enterFullScreen();
            });
            $("#ctrlaltdel").click(function(){
                console.log("Sending ctrl+alt+delete");
                wmks.sendCAD();
            });
            $("#startvm").click(function(){
                var xmlhttp;

                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }

                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?startvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();
            });
            $("#stopvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?stoptvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();

            });
            $("#suspendvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?suspendvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();

            });
            $("#resetvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?resetvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();
            });
            $(window).resize(function() {
                //adjust console size
                console.log("Browser window changed, Attempting to adjust VM console to new display mode...");
                wmks.updateScreen();
            });
        });
    </script >
    <title><?php echo $vmName; ?> Console</title>
</head>
<body>
    <h2 class="ui block header" style="background: white;">
        <img class="ui bottom aligned medium image" src="scc.jpg">
    <div class="ui right floated icon buttons">
        <div class="ui icon buttons">
            <button id="startvm" class="ui button">
                <i class="play icon"></i>
            </button>
            <button id="stopvm" class="ui button">
                <i class="stop icon"></i>
            </button>
            <button id="suspendvm" class="ui button">
                <i class="pause icon"></i>
            </button>
            <button id="resetvm" class="ui button">
                <i class="refresh icon"></i>
            </button>
        </div>
        <div class="ui icon buttons">
            <button id="fullscreen" class="ui button">
                <i class="maximize icon"></i>
            </button>
            <button id="ctrlaltdel" class="ui button">
                <i class="keyboard icon"></i>
            </button>
        </div>
    </div>
   </h2>
    <div  id="wmksContainer"  style="position:absolute;width:100%;height:89%">
    </div>

</body>
</html>

<?php
function getMKS($service,$orgName,$vApp,$vm)
{
    //Get MKS ticket from vm in vApp from orgName
    $orgRefs = $service->getOrgRefs($orgName);
    if (!empty($orgRefs)) {
        $sdkOrg = $service->createSDKObj($orgRefs[0]);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                $sdkVdc = $service->createSDKObj($vdcRef);
                $vappRefs = $sdkVdc->getVAppRefs();
                if (!empty($vappRefs)) {
                    foreach ($vappRefs as $vappRef) {
                        if($vappRef->get_name() == $vApp) {
                            $sdkvApp = $service->createSDKObj($vappRef);
                            $vmRefs = $sdkvApp->getContainedVmRefs();
                            foreach ($vmRefs as $vmRef) {
                                if ($vmRef->get_name() == $vm) {
                                    $sdkVm = $service->createSDKObj($vmRef);
                                    try {
                                        $ticketObj = $sdkVm->acquireMksTicket();
                                        return $ticketObj;
                                    } catch (Exception $e) {
                                        return; //Return nothing if failed. Like when the VM is off
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

// log out
    $service->logout();
}

function startVM($service,$orgName,$vApp,$vm)
{
    //Start a stopped VM
    $orgRefs = $service->getOrgRefs($orgName);
    if (!empty($orgRefs)) {
        $sdkOrg = $service->createSDKObj($orgRefs[0]);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                $sdkVdc = $service->createSDKObj($vdcRef);
                $vappRefs = $sdkVdc->getVAppRefs();
                if (!empty($vappRefs)) {
                    foreach ($vappRefs as $vappRef) {
                        if($vappRef->get_name() == $vApp) {
                            $sdkvApp = $service->createSDKObj($vappRef);
                            $vmRefs = $sdkvApp->getContainedVmRefs();
                            foreach ($vmRefs as $vmRef) {
                                if ($vmRef->get_name() == $vm) {
                                    $sdkVm = $service->createSDKObj($vmRef);
                                    try {
                                        $sdkVm->powerOn();
                                    } catch (Exception $e) {
                                        return; //Return nothing if failed. Like when the VM is off
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

// log out
    $service->logout();
}

function stopVM($service,$orgName,$vApp,$vm)
{
    //Stop a running VM
    $orgRefs = $service->getOrgRefs($orgName);
    if (!empty($orgRefs)) {
        $sdkOrg = $service->createSDKObj($orgRefs[0]);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                $sdkVdc = $service->createSDKObj($vdcRef);
                $vappRefs = $sdkVdc->getVAppRefs();
                if (!empty($vappRefs)) {
                    foreach ($vappRefs as $vappRef) {
                        if($vappRef->get_name() == $vApp) {
                            $sdkvApp = $service->createSDKObj($vappRef);
                            $vmRefs = $sdkvApp->getContainedVmRefs();
                            foreach ($vmRefs as $vmRef) {
                                if ($vmRef->get_name() == $vm) {
                                    $sdkVm = $service->createSDKObj($vmRef);
                                    try {
                                        $sdkVm->powerOff();
                                    } catch (Exception $e) {
                                        return; //Return nothing if failed. Like when the VM is off
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

// log out
    $service->logout();
}

function suspendVM($service,$orgName,$vApp,$vm)
{
    //Suspend VM
    $orgRefs = $service->getOrgRefs($orgName);
    if (!empty($orgRefs)) {
        $sdkOrg = $service->createSDKObj($orgRefs[0]);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                $sdkVdc = $service->createSDKObj($vdcRef);
                $vappRefs = $sdkVdc->getVAppRefs();
                if (!empty($vappRefs)) {
                    foreach ($vappRefs as $vappRef) {
                        if($vappRef->get_name() == $vApp) {
                            $sdkvApp = $service->createSDKObj($vappRef);
                            $vmRefs = $sdkvApp->getContainedVmRefs();
                            foreach ($vmRefs as $vmRef) {
                                if ($vmRef->get_name() == $vm) {
                                    $sdkVm = $service->createSDKObj($vmRef);
                                    try {
                                        $sdkVm->suspend();
                                    } catch (Exception $e) {
                                        return; //Return nothing if failed. Like when the VM is off
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

// log out
    $service->logout();
}

function resetVM($service,$orgName,$vApp,$vm)
{
    //Reset VM
    $orgRefs = $service->getOrgRefs($orgName);
    if (!empty($orgRefs)) {
        $sdkOrg = $service->createSDKObj($orgRefs[0]);
        $vdcRefs = $sdkOrg->getVdcRefs();
        if (!empty($vdcRefs)) {
            foreach ($vdcRefs as $vdcRef) {
                $sdkVdc = $service->createSDKObj($vdcRef);
                $vappRefs = $sdkVdc->getVAppRefs();
                if (!empty($vappRefs)) {
                    foreach ($vappRefs as $vappRef) {
                        if($vappRef->get_name() == $vApp) {
                            $sdkvApp = $service->createSDKObj($vappRef);
                            $vmRefs = $sdkvApp->getContainedVmRefs();
                            foreach ($vmRefs as $vmRef) {
                                if ($vmRef->get_name() == $vm) {
                                    $sdkVm = $service->createSDKObj($vmRef);
                                    try {
                                        $sdkVm->reset();
                                    } catch (Exception $e) {
                                        return; //Return nothing if failed. Like when the VM is off
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

// log out
    $service->logout();
}

function draw_eCloud_login()
{
    //Draw the main Login page to the VM list/console
    ?>
        <style>
            body {
                background-color: #004C8A;
                padding-top: 10%;
                padding-left:20%;
                padding-right:20%;
            }
        </style>
    </head>
    <body>
        <h2 class="ui block header" style="background: white;border-radius: 50px;padding-left: 20%;">
            <img class="ui top aligned large image" src="scc.jpg">
            <br/>
            <br/>
            <form name="cloudLoginForm" method="POST">
                <div class="ui labeled input">
                    <div class="ui label">
                    Username
                    </div>
                    <input name="cloudUser" type="text"/>
                </div>
                <br/>
                <div class="ui labeled input">
                    <div class="ui label">
                    Password&nbsp;
                    </div>
                    <input name="cloudPassword" type="password"/>
                </div>
                <br/>
                <br/>
                <input class="huge ui primary button" type="submit" name="cloudLogin" value="Login"/>
                <br/>
            </form>
        </h2>
    </body>
    </html>
    <?php
}

function cloudLogin($cloudUser,$cloudPass) {
    //This function will attempt to log in to vCloud, if successful it will return the token needed for the sesssion
    require '/home/phil/vcloudPHP-5.5.0/scratch/config.php';

    // Initialize parameters
    $httpConfig = array('ssl_verify_peer' => false, 'ssl_verify_host' => false);

    // login
    try {
        $service = VMware_VCloud_SDK_Service::getService();
        $service->login($server, array('username' => $cloudUser, 'password' => $cloudPass), $httpConfig, $sdkVersion);

        $token = $service->getToken();

        return $token; //Successful login, return Token

    } catch (Exception $e) {
        //Login failed
        return;
    }
}

function drawVms($service) {
    //Draw the simplified UI of VM's their power state and a console launcher
    ?>
    <script>
        $(document).ready(function() {
            $("#startvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?startvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();
            });
            $("#stopvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?stoptvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();

            });
            $("#suspendvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?suspendvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();

            });
            $("#resetvm").click(function(){
                var xmlhttp;
                if(window.XMLHttpRequest) {
                    xmlhttp=new XMLHttpRequest();
                } else {
                    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
                }
                xmlhttp.onreadystatechange=function() {
                    if(xmlhttp.readyState==4) {
                        if (xmlhttp.status == 200) {
                            //alert(xmlhttp.responseText);
                        } else {

                        }
                    }
                }
                xmlhttp.open("GET","http://<?php echo $siteIp; ?>webMKS/index.php?resetvm=1&consoleVM=" + "<?php echo htmlspecialchars($vmName);?>" + "&consoleOrg=" + "<?php echo htmlspecialchars($orgName); ?>" + "&consolevApp=" + "<?php echo htmlspecialchars($vApp);?>");
                xmlhttp.send();
            });
        });
    </script>
    <title>Server Cloud Canada</title>
    </head>
    <body>
    <h2 class="ui block header" style="background: white;">
        <img class="ui bottom aligned medium image" src="scc.jpg">
    </h2>
    <table class="ui celled table">
        <thead>
        <tr><th>VM</th>
            <th>vApp</th>
            <th>Status</th>
            <th>Actions</th>
            <th>Console</th>
        </tr></thead>
        <tbody>
        <?php
        $orgRefs = $service->getOrgRefs();
        if (!empty($orgRefs)) {
            foreach ($orgRefs as $orgRef) {
                $sdkOrg = $service->createSDKObj($orgRef);
                $vdcRefs = $sdkOrg->getVdcRefs();
                if (!empty($vdcRefs)) {
                    foreach ($vdcRefs as $vdcRef) {
                        $sdkVdc = $service->createSDKObj($vdcRef);
                        $vappRefs = $sdkVdc->getVAppRefs();
                        if (!empty($vappRefs)) {
                            foreach ($vappRefs as $vappRef) {
                                $sdkvApp = $service->createSDKObj($vappRef);
                                $vmRefs = $sdkvApp->getContainedVmRefs();
                                foreach ($vmRefs as $vmRef) {
                                        $sdkVM = $service->createSDKObj($vmRef);
                                        $vmStatus = $sdkVM->getStatus();
                                        ?>
                                    <tr>
                                        <td>
                                            <?php echo $vmRef->get_name(); ?>
                                        </td>
                                        <td><?php echo $vappRef->get_name(); ?></td>
                                        <td><?php drawVmStatus($vmStatus);?></td>
                                        <td><?php drawVmButtons($vmStatus);?></td>
                                        <td>
                                            <form name="consoleLaunch" method="GET">
                                                <input type="hidden" name="consoleVM" value="<?php echo $vmRef->get_name(); ?>"/>
                                                <input type="hidden" name="consolevApp" value="<?php echo $vappRef->get_name() ?>"/>
                                                <input type="hidden" name="consoleOrg" value="<?php echo $orgRef->get_name() ?>"/>
                                                <input type="submit" name="consoleLaunch" value="launch" formtarget="<?php echo $vmRef->get_name(); ?>"/>
                                            </form>
                                        </td>
                                    </tr>
                                    <?php
                                    }
                                }
                            }
                        }
                    }
                }
            }
        ?>
        </tbody>
        <tfoot>
        <tr><th colspan="3">
                <div class="ui right floated pagination menu">
                    <a class="icon item">
                        <i class="left chevron icon"></i>
                    </a>
                    <a class="item">1</a>
                    <a class="item">2</a>
                    <a class="item">3</a>
                    <a class="item">4</a>
                    <a class="icon item">
                        <i class="right chevron icon"></i>
                    </a>
                </div>
            </th>
        </tr></tfoot>
    </table>
    </body>
    </html>
<?php
}

function drawVmButtons($status) {
    ?>
    <div class="ui icon buttons">
        <button id="startvm" class="ui button">
            <i class="play icon"></i>
        </button>
        <button id="stopvm" class="ui button">
            <i class="stop icon"></i>
        </button>
        <button id="suspendvm" class="ui button">
            <i class="pause icon"></i>
        </button>
        <button id="resetvm" class="ui button">
            <i class="refresh icon"></i>
        </button>
    </div>
    <?php
}

function drawVmStatus($status) {
   if ($status == 4) echo "Powered On";
   if ($status == 8) echo "Powered Off";
   if ($status == 3) echo "Suspended";
}
?>