#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <signal.h>

#define DEFAULT_BUFLEN 512
#define DEFAULT_PORT "11000"

void do_sighup();

int main() {
   char *sendbuf = "REGISTER SSH\n";
   char recvbuf[DEFAULT_BUFLEN];
   char *host = "wdc-lab-apidev.wsl.vmware.com";
   int recvbuflen = DEFAULT_BUFLEN;
   int numbytes;

   signal(SIGHUP,do_sighup);

   struct hostent *he;
   struct sockaddr_in their_addr; // connector's address information
   int fd;

   if ((he = gethostbyname(host)) == NULL) {
      return -1;
   }


   if ((fd = socket(AF_INET, SOCK_STREAM, 0)) == -1) { //Set up socket for use
      return -1;
   }

   their_addr.sin_family = AF_INET;    // host byte order
   their_addr.sin_port = htons(atoi(DEFAULT_PORT));  // short, network byte order
   their_addr.sin_addr = *((struct in_addr *)he->h_addr);
   memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct

   if (connect(fd, (struct sockaddr *)&their_addr,
      sizeof(struct sockaddr)) == -1) {
      return -1;
   }

   numbytes = send( fd,sendbuf, (int)strlen(sendbuf), 0 );

   if (numbytes <= 0) {
      printf("send failed with error\n");
      return 1;
   } 

   //printf("Bytes Sent: %ld\n", numbytes);

   do {
      numbytes = recv(fd,recvbuf,recvbuflen,0);

      if ( numbytes > 0 ) {
         if(strncmp(recvbuf,"PING",4) == 0) {
            numbytes = send( fd,"PONG\n", (int)strlen("PONG\n"), 0 );
               if (numbytes <= 0) {
                  printf("send failed with error\n");
                  return 1;
               }        
            }
            //printf("Bytes received: %d\n", numbytes);
		    
      } else if ( numbytes == 0 ) {
         printf("Connection closed\n");
         break;
      } else {
         printf("recv failed with error\n");
         break;
      }
      
      
   } while(1 != 0);   

}

void do_sighup()
{
   exit(1);
}