<?php

$home = "/home/reference";

$url = "http://vapp-access.csl.vmware.com/vmrcvcd55/refconsoleadmin.php";

if(!isset($_GET["vapp"]) || !isset($_GET["vm"])) {
   echo "ERROR: vApp or VM variable missing. Cannot proceed\n";
   exit(1);
}

if(isset($_GET["region"]))
   $region = $_GET["region"];
else
   $region = 1;

if(isset($_GET["type"]))
   $type = $_GET["type"];
else
   $type = 1;

if($type == 1) {
   require_once($home . "/etc/gss-reference" . $region . ".php");
   $orgName = "GSS-Reference";
} else {
   require_once($home . "/etc/gss-repro" . $region . ".php");
   $orgName = "GSS-Repro";
}

$vApp = $_GET["vapp"];
$vm   = $_GET["vm"];

// Initialize Global parameters
$httpConfig = array('ssl_verify_peer'=>false, 'ssl_verify_host'=>false);
  
// login
$service = VMware_VCloud_SDK_Service::getService();
$service->login($server, array('username'=>$user, 'password'=>$pswd), $httpConfig);

$orgRefs = $service->getOrgRefs($orgName);
if(empty($orgRefs)) {
   echo "Invalid Org\n";
   return -1;
}

$sdkOrg = $service->createSDKObj($orgRefs[0]);

$vdcRefs  = $sdkOrg->getVdcRefs();
$sdkVdc   = $service->createSDKObj($vdcRefs[0]); //our cloud only has one vDC per ORG currently, can cheat here
$vAppRefs = $sdkVdc->getVAppRefs($vApp);
if(!empty($vAppRefs))
{
   $vAppRef = $vAppRefs[0];
   $sdkvApp = $service->createSDKObj($vAppRef);
   $vmRefs  = $sdkvApp->getContainedVmRefs($vm);
   if(!empty($vmRefs)) {
      $vmRef = $vmRefs[0];
      $sdkVM = $service->createSDKObj($vmRef);
      if($sdkVM->getStatus() == 4) {
         $tickets = $sdkVM->getScreenTicketTokens();
         $mks = sprintf("mks://%s/%s?ticket=%s",$tickets["ip"],$tickets["mof"],$tickets["ticket"]);
         $ticket = $tickets["ticket"];  
         //$ticket = urldecode($mks);
         $vmid = $tickets["mof"];
         $redirect = sprintf("Location: %s?ticket=%s&vmid=%s",$console,urlencode($mks),$tickets["mof"]);
         console55_output($tickets["ip"]);
         $service->logout(); 
         return;
      }
   }
}

function console55_output($hostname) {
   global $ticket;
   global $vmid;

   //$hostname   = "vcore5-us01-console.oc.vmware.com";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <title></title>

        <link href="support/css/jquery-ui-1.7.3.custom.css" rel="stylesheet" type="text/css" />
        <link href="support/css/jquery-dialog-override.css" rel="stylesheet" type="text/css" />
        <link href="support/css/vmrc.css" rel="stylesheet" type="text/css" />
        <script src="support/javascript/jquery-1.7.2.min.js" type="text/javascript"></script>
        <script src="support/javascript/jquery-ui-1.7.3.custom.min.js" type="text/javascript" ></script>
        <script src="support/javascript/core.js" type="text/javascript"></script>
        <script src="support/javascript/normalize-constants.js" type="text/javascript"></script>
        <script src="support/javascript/debug.js" type="text/javascript"></script>
        <script src="support/javascript/alert.js" type="text/javascript"></script>
        <script src="support/javascript/confirm.js" type="text/javascript"></script>
        <script src="support/javascript/dialog.js" type="text/javascript"></script>
        <script src="support/javascript/event-manager.js" type="text/javascript"></script>
        <script src="support/javascript/button.js" type="text/javascript"></script>
        <script src="support/javascript/button-manager.js" type="text/javascript"></script>
        <script src="support/javascript/VMRCPluginControllerAdmin.js" type="text/javascript"></script>
        <script src="support/javascript/VMRCExternalInterfaceController.js" type="text/javascript"></script>
        <script src="support/javascript/VMRCDeviceManagementController.js" type="text/javascript"></script>
        <script type="text/javascript">
            $(function () {
                    var phpdata = {
                buttonLabels: {
                   0: "Send Ctrl-Alt-Del",
                   1: "Send Ctrl-Alt-Del (disabled)",
                   2: "Full Screen",
                   3: "Full Screen (disabled)",
                   4: "CD/DVD",
                   5: "CD/DVD (disabled)",
                   6: "Floppy",
                   7: "Floppy (disabled)",
                   8: "Fit Window to Guest",
                   9: "Fit Window to Guest (disabled)",
                  10: "USB",
                  11: "USB (disabled)"
                },
                vmDevicesAvailable: {
                   0: false,
                   1: false,
                   2: false
                },
                miscLabels: {
                   0: "Connecting...",
                   1: "Disconnected",
                   3: "Failed to connect",
                   4: "None",
                   5: "Cancel",
                   6: "Browse",
                   7: "Manage CDs/DVDs",
                   8: "Choose the CD or DVD to attach to this VM, Onle one device can be attached at a time.",
                   9: "Manage Floppys",
                  10: "Choose the Floppy drive to attach to this VM. Only one device can be attached at a time.",
                  11: "Manage USBs",
                  12: "Choose the USB drive()s to attach to this VM.",
                  13: "Copy and paste the full path of the device you want to attach",
                  14: "Client device access is disabled",
                  15: "Device",
                  16: "Error",
                  17: "Operation Failed. Please verify the vCD session is still active.",
                  18: "No Client devices are available.",
                  19: "Connect {0}",
                  20: "Disconnect {0}",
                  21: "No virtual CD/DVD device found",
                  22: "No virtual gloppy device found"
                },
                confirmationLabels: {
                   0: "Confirm Power On",
                   1: "Power On Virtual Machine {0}",
                   2: "Confirm Suspend",
                   3: "Suspending Virtual Machine {0}",
                   4: "Confirm Power Off",
                   5: "Power Off Virtual Machine {0}?",
                   6: "Confirm Reset",
                   7: "Reset Virtual Machine {0}?",
                   8: "Power On",
                   9: "Suspend",
                  10: "Power Off",
                  11: "Reset",
                  12: "Stop Requested",
                  13: "Suspend requested",
                },
                vmName: "<?php echo $_GET["vm"];?>",
                vmId: "<?php echo $vmid;?>",
                vmDevicesAvailable: ""
                 
            };
                    
                    var init = function () {
                        vmware.log("TRACE", "init", "initializing");

                        initPlugin(phpdata);

                        /* Register the unload instructions only if init is run. */
                        $(window).unload(function () {
                            uninit();
                        });
                    };
                    init();
                    connectControl("vmrc", "<?php echo $hostname; ?>", "<?php echo $vmid; ?>","<?php echo $ticket; ?>")
                    
                
            });
        </script>
    </head>

    <body>
        <div id="header">
            <div id="heading"></div>
            <div id="buttonArea" style="float:right" >
                <span id="busyArea">Connecting...</span>
                <span id="power-buttons"></span>
                <img src="support/images/separator.png" />
                <span id="device-buttons"></span>
                <img src="support/images/separator.png" />
                <span id="plugin-buttons"></span>
            </div>
            <h1 id="vmName"></h1>
            <div style="clear:both"></div>
        </div>

        <div id="vmrcObject"></div>
    </body>
</html>
<?php
}

function console_output() {
   global $ticket;
   global $vmid;

   $hostname   = "vcore5-us01-console.oc.vmware.com";
//   $user       = 'c_oc_t_gss-labs_api@GSS-Reference';
//   $pswd       = 'E7$d@b^9mN';
   $thumbprint = "f3:a0:86:53:82:06:04:41:f7:16:44:cd:9a:46:5f:37:f7:77:a7:3f";
   echo $ticket . " ";
   echo $vmid;
?>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>VMware Remote Console API Example</title>
    <script type="text/javascript" src="vmrc-embed-example.js"></script>
  </head>
<body onload="init()">
<div style="float:right;" onload="startup()">
   <div style="border: solid 2px blue; width: 640px; height: 480px;" id="pluginPanel"></div>
   <div style="overflow: auto; height: 400px; width: 640px;" id="msgBox"></div>
</div>
<div>
<input type="button" onclick="getVersion()" value="getVersion"/>
   <input type="button" onclick="isReadyToStart()" value="isReadyToStart"/>
<input type="button" onclick="startup()" value="startup"/>
   <input type="button" onclick="shutdown()" value="shutdown"/>
<table>
   <tr><td valign="top">VMRC modes:</td><td><select id="VMRC_Mode"></select>
       <input type="button" onclick="addToModeMask()" value="+"/><br/>
       <div id="mode_mask"></div></td></tr>
   <tr><td>Message mode:</td><td><select id="VMRC_MessageMode"></select></td></tr>
   <tr><td>Advanced config:</td><td><input type="text" id="startup_advanced"/></td></tr>
   </table>
<input type="button" onclick="grabInput()" value="grabInput"/>
   <input type="button" onclick="ungrabInput()" value="ungrabInput"/>
<input type="button" onclick="sendCAD()" value="sendCAD"/>
<input type="hidden" id="connect_host" value="<?php echo $hostname; ?>"/></td></tr>
<input type="hidden" id="connect_thumbprint" value="<?php echo $thumbprint; ?>"/></td></tr>
<input type="hidden" id="connect_allow_ssl_errors" value="1"/></td></tr>
<input type="hidden" id="connect_ticket" value="<?php echo $ticket;?>"/></td></tr>
<input type="hidden" id="connect_username" value="<?php echo $user; ?>"/></td></tr>
<input type="hidden" id="connect_password" value="<?php echo $pswd; ?>"/></td></tr>
<input type="hidden" id="connect_vmid" value="<?php echo $vmid;?>"/></td></tr>
<input type="hidden" id="connect_datacenter"/></td></tr>
<input type="hidden" id="connect_vmpath"/></td></tr>
<input type="button" onclick="connect()" value="connect"/>
</body>
</html>
<?php
}
?>

