var eic = (function(){
    // return the SWF object that represents the application
    var getSWFApplication = function() {
        if (!window.opener || !window.opener.document.application) {
            return undefined;
        }

        return window.opener.document.application;
    };

    var verifySessionAndCall = function(handler) {
        if (getSWFApplication() && window.opener.windowData && window.opener.windowData.get(window)) {
            handler();
        } else {
            hideConsole();
            vmware.alert("Error".localize(), "Operation failed. Please verify vCD session is still active.".localize(), showConsole);
        }
    };

    var wrapWithConfirmation = function(delegate, title, body) {
        return verifySessionAndCall.curry(function () {
            hideConsole();
            vmware.confirm(title.localize(),
                body.localize(vmName),
                showConsole,
                delegate);
        });
    };

    var acquireTicket = function(objectId) {
/*        getSWFApplication().acquireTicket(vmName, vmId, objectId); */
    };

    var powerOn = function() {
        getSWFApplication().popoutPowerOn(vmName, vmId);
    };

    var powerPause = function () {
        getSWFApplication().popoutPowerPause(vmName, vmId);
    };

    var powerOff = function() {
        getSWFApplication().popoutPowerOff(vmName, vmId);
    };

    var powerReset = function() {
        getSWFApplication().popoutPowerReset(vmName, vmId);
    };

    var setClientDeviceBacking = function(deviceId, deviceType) {
        verifySessionAndCall(function() {
            getSWFApplication().setClientDeviceBacking(vmName, vmId, deviceId, deviceType);
        });
    };

    return {acquireTicket: acquireTicket,
        powerOn: wrapWithConfirmation(powerOn, "Confirm Power On", "Power On Virtual Machine {0}?"),
        powerPause: wrapWithConfirmation(powerPause, "Confirm Suspend", "Suspend Virtual Machine {0}?"),
        powerOff: wrapWithConfirmation(powerOff, "Confirm Power Off", "Power Off Virtual Machine {0}?"),
        powerReset: wrapWithConfirmation(powerReset, "Confirm Reset", "Reset Virtual Machine {0}?"),
        setClientDeviceBacking: setClientDeviceBacking};
})();