<?php

require_once "config.php";

$maxBandwidth = 100000000; //100Mbit

$dvsPortgroups = $vHost->findAllManagedObjects('DistributedVirtualPortgroup',array('config'));

foreach ($dvsPortgroups as $dvsPortgroup) {
//    echo var_dump($dvsPortgroup);

    $config = $dvsPortgroup->config;
    if(strncmp($config->name,"dvs.VCDVS",8) == 0 ) {
	    $change = 0;
        $portConfig    = $config->defaultPortConfig;
	    $ingressPolicy = $portConfig->inShapingPolicy->enabled->value;
	    $egressPolicy  = $portConfig->outShapingPolicy->enabled->value;
	    $ingressAvg    = $portConfig->inShapingPolicy->averageBandwidth->value;
        $ingressPeak   = $portConfig->inShapingPolicy->peakBandwidth->value;
        $egressAvg     = $portConfig->outShapingPolicy->averageBandwidth->value;
        $egressPeak    = $portConfig->outShapingPolicy->peakBandwidth->value;
	    if(!$ingressPolicy || !$egressPolicy) {
            //Policy not enabled
            echo $config->name . " traffic shaping not enabled\n";
            $config->defaultPortConfig->inShapingPolicy->enabled->value  = boolval(1);
            $config->defaultPortConfig->inShapingPolicy->enabled->inherited = FALSE;
            $config->defaultPortConfig->outShapingPolicy->enabled->value = boolval(1);
            $config->defaultPortConfig->outShapingPolicy->enabled->inherited = FALSE;     
            $config->defaultPortConfig->outShapingPolicy->inherited = FALSE;
            $config->defaultPortConfig->inShapingPolicy->inherited  = FALSE;
            $change = 1;
	    }
	    if($ingressPeak > $maxBandwidth) {
            echo $config->name . " ingress Peak exceeds limit\n";
            $config->defaultPortConfig->inShapingPolicy->peakBandwidth->value = $maxBandwidth;
            $change = 1;
        }
        if($ingressAvg > $maxBandwidth) {
            echo $config->name . " ingress Average exceeds limit\n";
            $config->defaultPortConfig->inShapingPolicy->averageBandwidth->value = $maxBandwidth;
            $change = 1;	
        }
        if($egressPeak > $maxBandwidth) {
            echo $config->name . " egress Peak exceeds limit\n";
            $config->defaultPortConfig->outShapingPolicy->peakBandwidth->value = $maxBandwidth;
            $change = 1;
        }
        if($egressAvg > $maxBandwidth) {
            echo $config->name . " egress Average exceeds limit\n";
            $config->defaultPortConfig->outShapingPolicy->peakBandwidth->value = $maxBandwidth;
            $change = 1;
        }
        if($change == 1) {

            $portSpec = array();
            $portSpec["autoExpand"]           = $config->autoExpand;
            $portSpec["configVersion"]        = $config->configVersion;
            $portSpec["defaultPortConfig"]    = $config->defaultPortConfig;
            $portSpec["description"]          = $config->description;
            $portSpec["name"]                 = $config->name;
            $portSpec["numPorts"]             = $config->numPorts;
            $portSpec["policy"]               = $config->policy;
            $portSpec["portNameFormat"]       = $config->portNameFormat;
            $portSpec["scope"]                = $config->scope;
            $portSpec["type"]                 = $config->type;
            $portSpec["vendorSpecificConfig"] = $config->vendorSpecificConfig;
                      
	        $task = $dvsPortgroup->ReconfigureDVPortgroup_Task(array('spec' => $portSpec));
            while(!$task->info->completeTime) {
               echo ".";
               sleep(1);

            }

        }
    }
}

?>

