<?php
/**
 * Created by PhpStorm.
 * User: phil.spencer
 * Date: 10/25/2016
 * Time: 1:12 PM
 */
require_once'Console/Table.php';
require_once "config.php";
require_once "vcenterfunctions.inc";

$vmReport = new Console_Table();
$vmReport->setHeaders(array("VM","MAC","Switch","Type","Host"));
$reportArray = array();

$search = buildArgString();
$dvsArray = populateDVSSwitch($vHost);

$virtualMachines = $vHost->findAllManagedObjects('VirtualMachine',array('config','runtime'));
//echo array_dump($virtualMachines);

foreach ($virtualMachines as $virtualMachine) {
        try {
            $vmConfig    = $virtualMachine->config;
            $vmRuntime   = $virtualMachine->runtime;
        } catch (Exception $e) { }
        $vmHardware = $vmConfig->hardware;
        $vmDevices  = $vmHardware->device;
        $host       = $vmRuntime->host->name;
        foreach ($vmDevices as $vmDevice) {
            if(isNIC($vmDevice)) {
                if(isset($vmDevice->backing->port->switchUuid))
                    $switch = $dvsArray[$vmDevice->backing->port->switchUuid];
                else
                    $switch = "none";
                $nicID = str_replace("Network adapter ","",$vmDevice->deviceInfo->label);
                $key = sprintf("%s %s",$virtualMachine->name , $nicID); //it got pissed when I tried to do this in the definition of the array
                $reportArray[$key] = array($vmDevice->macAddress,$switch,$vmDevice->addressType,$host);
            }
        }

}
arsort($reportArray);

foreach($reportArray as $reportKey => $value) {
    if($search != "") {
        if(strstr($value[0],$search)) {
            $vmReport->addRow(array($reportKey, $value[0], $value[1]));
        }
    } else {
        $vmReport->addRow(array($reportKey, $value[0], $value[1],$value[2],$value[3]));
    }
}

echo $vmReport->getTable();

function isNIC($vmDevice) {
    //Takes a VirtualMachine->hardware->device object
    //check if object is a vSphere NIC type
    switch(get_class($vmDevice)) {
        case "VirtualVmxnet3": return 1;
        case "VirtualVmxnet2": return 1;
        case "VirtualVmxnet" : return 1;
        case "VirtualE1000"  : return 1;
        case "VirtualE1000e" : return 1;
        case "VirtualPCNet32": return 1;
        default : return 0;
    }
}

function buildArgString()
{
    global $argv;
    $argString = "";

    foreach($argv as $value)
    {
        if($value != $_SERVER['PHP_SELF']) {
            if ($argString == "")
                $argString = sprintf("%s", $value);
            else if ($argString == $_SERVER['PHP_SELF'])
                $argString = sprintf("%s", $value);
            else
                $argString = sprintf("%s %s", $argString, $value);
        }
    }
    return $argString;
}

function populateDVSSwitch($vHost) {
    $returnSwitches = array();
    $dvsSwitches = $vHost->findAllManagedObjects('DistributedVirtualSwitch',array('summary'));

    foreach ($dvsSwitches as $dvsSwitch)
    {
        $returnSwitch[$dvsSwitch->summary->uuid] = $dvsSwitch->summary->name;
    }

    return $returnSwitch;
}
?>