<?php

require_once "config.php";

$search = buildArgString();

$virtualMachines = $vHost->findAllManagedObjects('VirtualMachine',array('runtime','summary'));
//echo array_dump($virtualMachines);

foreach ($virtualMachines as $virtualMachine) {
   if(strstr($virtualMachine->name,$search)) { 
      try {
          $vmSummary    = $virtualMachine->summary; 
          $vmRuntime    = $virtualMachine->runtime;
          $resourcePool = $virtualMachine->resourcePool;
          $host         = $vmRuntime->host;
      } catch (Exception $e) { }
      if ($vmRuntime->powerState == "poweredOn") { //Only output running VMs
          $vmFolder = $virtualMachine->parent;
          echo $virtualMachine->name . "\n";
          echo "Host: " . $host->name . "\n";
          echo "Resource Pool: " . $resourcePool->name . "\n";
         
          $vmQuickStats = $vmSummary->quickStats;
          $vmStorage = $vmSummary->storage;
          echo "Active memory: " . $vmQuickStats->guestMemoryUsage . "MB\n";
          echo "Active CPU: " . $vmQuickStats->overallCpuUsage . "MHZ\n";
          echo "Used Storage: " . round(($vmStorage->committed / 1024 / 1024 / 1024),2) . "GB\n\n";
      }
   }
}

function buildArgString()
{
    global $argv;
    $argString = "";

    foreach($argv as $value)
    {
    	if($argString == "")
           $argString = sprintf("%s",$value);
	else if($argString == $_SERVER['PHP_SELF'])
           $argString = sprintf("%s",$value);
	else
           $argString = sprintf("%s %s",$argString,$value);
    }
    return $argString;
}
?>

