# PowerCLI Script to Configure DNS and NTP on ESXi Hosts
# PowerCLI Session must be connected to vCenter Server using Connect-VIServer
 
# Prompt for Primary and Alternate DNS Servers
$cluster = "Kingston"
$dnspri = "192.168.253.2"
$dnsalt = "192.168.253.66"
 
 
$esxHosts = get-VMHost -Location $cluster
 
foreach ($esx in $esxHosts) {
 
   Write-Host "Configuring DNS and Domain Name on $esx" -ForegroundColor Green
   Get-VMHostNetwork -VMHost $esx | Set-VMHostNetwork -DNSAddress $dnspri , $dnsalt -Confirm:$false
  
}
Write-Host "Done!" -ForegroundColor Green